<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 04/25/2004 *
 * ================                             Last change: 04/29/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : html_mail_functions.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Functions for the HTML extension                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Funktionen fuer die HTML-Erweiterung             *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

//
function HTML_ADD_VALID_TAGS() {
	$OUT = "";
	if (!is_array($GLOBALS['html_tags'])) return "";
	foreach ($GLOBALS['html_tags'] as $tag) {
		$OUT .= ", ".strtoupper($tag);
	}
	$OUT = substr($OUT, 2);
	return $OUT;
}
//
function HTML_CHECK_TAGS ($html) {
	$test = stripslashes($html);
	while (ereg("<", $test) && ereg(">", $test)) {
		$check = strtolower(substr($test, strpos($test, "<") + 1, strpos($test, ">") - strpos($test, "<") - 1));
		$check = str_replace("/", "", $check);
		if (!in_array($check, $GLOBALS['html_tags'])) {
			// Invalid tag found!
			return "";
		}
		$test = substr($test, strpos($test, ">") + 1);
	}
	// Return tested code
	return $html;
}
//
function HTML_INSERT_URLS ($text) {
	$test = $text;

	// First replace URLs...
	while (ereg("http://", $test))
	{
		$check = substr($test, strpos($test, "http://")); $check2 = $check;

		// See ext-html.php if you want to add more URL ends...
		foreach ($GLOBALS['url_ends'] as $end)
		{
			if (ereg($end, $check)) $check = substr($check, 0, strpos($check, $end));
		}

		// Now replace the URL against anchor container and pray...
		$text = substr($text, 0, strpos($text, $check2))."<a href=\"".DEREFERER($check)."\" target=\"_blank\">".$check."</a>".substr($text, strpos($text, $check2) + strlen($check));

		// Finally remove the url from testing string (or we have a loop and maybe server overload!)
		$test = substr($test, strpos($test, $check) + strlen($check));
	}

	// Now do the (nearly) same thing with email addresses
	// but now we have the problem that email addresses didn't have
	// a start mark like http:// and our templates are lame didn't have
	// a mailto: ... :-(
	$test = $text;

	// ... what will the email address be out the @... ;-)
	$PARTS = array();
	while (ereg("@", $test))
	{
		$pos = strpos($test, "@");
		$test2 = substr($test, 0, $pos);

		// First check backwards
		$idx = $pos - 1;
		while ($idx > 0)
		{
			$check = substr($test2, $idx, 1);
			if (!in_array($check, $GLOBALS['valid_email_chars']))
			{
				// Char found so we end here
				break;
			}
			$idx--;
		}
		if ($idx > 0)
		{
			// Starting mark is found
			$check2 = substr($test, 0, ($idx + 1));
			$test = substr($test, ($idx + 1));
		}

		// And now go forward...
		$idx = 0;
		while ($idx < strlen($test))
		{
			$check = substr($test, $idx, 1);
			if ((!in_array($check, $GLOBALS['valid_email_chars'])) && ($check != "@"))
			{
				// Char found so end here again
				break;
			}
			$idx++;
		}
		if ($idx > 0)
		{
			// Maybe this is the email address?
			$check = substr($test, 0, $idx);
		}

		// Now replace the email against anchor with mailto and pray...
		$PARTS[] = $check2."<a href=\"mailto:".$check."\">".$check."</a>";

		// Remove email from testing string (see above why...)
		$test = substr($test, strlen($check));
	}
	// Now put all parts together
	$text = ""; $PARTS[] = $test;
	foreach ($PARTS as $part)
	{
		$text .= $part;
	}

	// Replace new-lines agains <br />-s and finally compile possible own HTML tags out...
	return COMPILE_CODE(str_replace("\n", "<br />\n", $text));
}
//
function SEND_HTML_EMAIL($TO, $SUBJECT, $MSG, $FROM)
{
	if (EXT_IS_ACTIVE("html_mail"))
	{
		// Send mail away as HTML
		$FROM = "Content-Type: text/html\n".$FROM;
		SEND_EMAIL($TO, $SUBJECT, $MSG, 'N', $FROM);
	}
}
//
?>
