<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/28/2003 *
 * ===============                              Last change: 06/10/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-lock_user.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Lock members                                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mitglieder sperren                               *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

// Is a userid set?
if (REQUEST_ISSET_GET(('uid'))) {
	// Load user's data
	$result_user = SQL_QUERY_ESC("SELECT status, gender, surname, family, email FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
	 array(bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);
	$ACT = false;
	if (SQL_NUMROWS($result_user) == 1) {
		// User found
		list($status, $gender, $sname, $fname, $email) = SQL_FETCHROW($result_user);

		// Free result
		SQL_FREERESULT($result_user);

		// Is a lock reason set?
		if ((REQUEST_ISSET_POST(('lock'))) && ($status != "LOCKED")) {
			// Ok, lock the account!
			if (GET_EXT_VERSION("user") >= "0.3.5") {
				// Lock with reason
				SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET `status`='LOCKED',lock_reason='%s',lock_timestamp=NOW() WHERE userid=%s LIMIT 1",
					array(REQUEST_POST('reason'), bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);
			} else {
				// Lock with no lock reason saved
				SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET `status`='LOCKED' WHERE userid=%s LIMIT 1",
					array(bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);
			}

			// Entry updated?
			if (SQL_AFFECTEDROWS() == 1) {
				// Send an email to the user! In later version you can optionally switch this feature off
				$msg = LOAD_EMAIL_TEMPLATE("lock-user", array('text' => REQUEST_POST('reason')), bigintval(REQUEST_GET('uid')));

				// Send away...
				SEND_EMAIL(bigintval(REQUEST_GET('uid')), ADMIN_LOCKED_SUBJ, $msg);
			} // END - if

			// Prepare message
			$MSG = USER_ACCOUNT_LOCKED_1.REQUEST_GET('uid').USER_ACCOUNT_LOCKED_2;
			$ACT = true;
		} elseif ((REQUEST_ISSET_POST(('unlock'))) && ($status == "LOCKED")) {
			// Ok, unlock the account!
			if (GET_EXT_VERSION("user") >= "0.3.5") {
				// Reset lock reason as well
				SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET `status`='CONFIRMED',lock_reason='',lock_timestamp='0000-00-00 00:00' WHERE userid=%s LIMIT 1",
					array(bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);
			} else {
				// No lock reason to reset
				SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET `status`='CONFIRMED' WHERE userid=%s LIMIT 1",
					array(bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);
			}

			// Entry updated?
			if (SQL_AFFECTEDROWS() == 1) {
				// Send an email to the user! In later version you can optionally switch this feature off
				$msg = LOAD_EMAIL_TEMPLATE("unlock-user", array('text' => REQUEST_POST('reason')), bigintval(REQUEST_GET('uid')));

				// Send away...
				SEND_EMAIL(bigintval(REQUEST_GET('uid')), getMessage('ADMIN_UNLOCKED_SUBJ'), $msg);
				if (EXT_IS_ACTIVE("rallye")) {
					RALLYE_AUTOADD_USER(REQUEST_GET('uid'));
				} // END - if
			} // END - if

			// Prepare message
			$MSG = USER_ACCOUNT_UNLOCKED_1.REQUEST_GET('uid').USER_ACCOUNT_UNLOCKED_2;
			$ACT = true;
		} elseif (REQUEST_ISSET_POST('del')) {
			// Delete the account
			$ACT = true;
			LOAD_INC_ONCE("inc/modules/admin/what-del_user.php");
		} elseif (REQUEST_ISSET_POST(('no'))) {
			// Do not lock him...
			$URL = "modules.php?module=admin&amp;what=list_user&amp;uid=".bigintval(REQUEST_GET('uid'));
		} else {
			$result = SQL_QUERY_ESC("SELECT email, surname, family FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
				array(bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);

			// Entry found?
			if (SQL_NUMROWS($result) == 1) {
				// Load data
				list ($email, $sname, $fname) = SQL_FETCHROW($result);

				// Free result
				SQL_FREERESULT($result);

				// Transfer data to constants for the template
				define('__EMAIL', CREATE_EMAIL_LINK($email, "user_data"));
				define('__SNAME', $sname);
				define('__FNAME', $fname);
				define('__UID'  , bigintval(REQUEST_GET('uid')));

				// Realy want to lock?
				switch ($status)
				{
				case "CONFIRMED": // Yes, lock him down... ;-)
					define('__OK_VALUE'    , "lock");
					define('__HEADER_VALUE', ADMIN_HEADER_LOCK_ACCOUNT_1.__UID.ADMIN_HEADER_LOCK_ACCOUNT_2);
					define('__TEXT_VALUE'  , ADMIN_TEXT_LOCK_ACCOUNT_1.__UID.ADMIN_TEXT_LOCK_ACCOUNT_2);
					break;

				case "LOCKED": // Unlock the user
					define('__OK_VALUE'    , "unlock");
					define('__HEADER_VALUE', ADMIN_HEADER_UNLOCK_ACCOUNT_1.__UID.ADMIN_HEADER_UNLOCK_ACCOUNT_2);
					define('__TEXT_VALUE'  , ADMIN_TEXT_UNLOCK_ACCOUNT_1.__UID.ADMIN_TEXT_UNLOCK_ACCOUNT_2);
					break;

				case "UNCONFIRMED": // Unconfirmed accounts cannot be unlocked!
					define('__OK_VALUE'    , "del");
					define('__HEADER_VALUE', ADMIN_HEADER_DEL_ACCOUNT_1.__UID.ADMIN_HEADER_DEL_ACCOUNT_2);
					define('__TEXT_VALUE'  , ADMIN_TEXT_DEL_ACCOUNT_1.__UID.ADMIN_TEXT_DEL_ACCOUNT_2);
					break;
				}

				// Output form
				LOAD_TEMPLATE("admin_lock_user");
			} else {
				// Account does not exists!
				LOAD_TEMPLATE("admin_settings_saved", false, "<div class=\"admin_failed\">".sprintf(getMessage('ADMIN_MEMBER_404'), REQUEST_GET('uid'))."</div>");
			}
		}

		// Is an URL set?
		if (!empty($URL)) {
			// Reload and die...
			LOAD_URL($URL);
		} elseif ($ACT) {
			// An action was performed...
			if (!empty($MSG)) {
				LOAD_TEMPLATE("admin_settings_saved", false, "<div class=\"admin_green\">".$MSG."</div>");
			} else {
				LOAD_TEMPLATE("admin_settings_saved", false, "<div class=\"admin_green\">".getMessage('ADMIN_USER_UPDATED')."</div>");
			}
		}
	} else {
		// Account does not exists!
		LOAD_TEMPLATE("admin_settings_saved", false, "<div class=\"admin_failed\">".sprintf(getMessage('ADMIN_MEMBER_404'), REQUEST_GET('uid'))."</div>");
	}
} else {
	// List all users
	ADD_MEMBER_SELECTION_BOX();
}

//
?>
