<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/28/2009 *
 * ===============                              Last change: 02/28/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : session-functions.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Session-relevant functions                       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sitzungsrelevante Funktionen                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}

// Unset/set session variables
function set_session ($var, $value) {
	// Abort in CSS mode here
	if ($GLOBALS['output_mode'] == 1) return true;

	// Trim value and session variable
	$var = trim(SQL_ESCAPE($var)); $value = trim($value);

	// Is the session variable set?
	if (("".$value."" == "") && (isSessionVariableSet($var))) {
		// Remove the session
		//* DEBUG: */ echo "UNSET:".$var."=".get_session($var)."<br />\n";
		unset($_SESSION[$var]);
		return session_unregister($var);
	} elseif (("".$value."" != '') && (!isSessionVariableSet($var))) {
		// Set session
		//* DEBUG: */ echo "SET:".$var."=".$value."<br />\n";
		$_SESSION[$var] =  $value;
		return session_register($var);
	} elseif (!empty($value)) {
		// Update session
		//* DEBUG: */ echo "UPDATE:".$var."=".$value."<br />\n";
		$_SESSION[$var] = $value;
		return true;
	}

	// Ignored (but valid)
	//* DEBUG: */ echo "IGNORED:".$var."=".$value."<br />\n";
	return true;
}

// Check wether a session variable is set
function isSessionVariableSet ($var) {
	//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>):var={$var}<br />\n";
	return (isset($_SESSION[$var]));
}

// Returns wether the value of the session variable or NULL if not set
function get_session ($var) {
	// Default is not found! ;-)
	$value = null;

	// Is the variable there or cached values?
	if (isset($GLOBALS['cache_array']['session'][$var])) {
		// Get cached value (skips a lot SQL_ESCAPE() calles!
		//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>): ".$var."-CACHE!<br />\n";
		$value = $GLOBALS['cache_array']['session'][$var];
	} elseif (isSessionVariableSet($var)) {
		// Then  get it secured!
		//* DEBUG: */ print __FUNCTION__."(<font color=\"#0000aa\">".__LINE__."</font>): ".$var."-RESOLVE!<br />\n";
		$value = SQL_ESCAPE($_SESSION[$var]);

		// Cache the value
		$GLOBALS['cache_array']['session'][$var] = $value;
	} // END - if

	// Return the value
	return $value;
}

// Destroy user session
function destroy_user_session () {
	// Reset userid
	setUserId(0);

	// Remove all user data from session
	return ((set_session('userid', "")) && (set_session('u_hash', "")));
}

// Destroys the admin session
function destroyAdminSession ($destroy = true) {
	// Kill maybe existing session variables including array elements
	set_session('admin_login', "");
	set_session('admin_md5'  , "");
	set_session('admin_last' , "");
	set_session('admin_to'   , "");

	// Destroy session and return status
	if ($destroy) {
		return session_destroy();
	} // END - if

	// All fine if we shall not really destroy the session
	return true;
}

// [EOF]
?>
